OGRE: Ogre::SimpleSpline Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::SimpleSpline Class Reference

A very simple spline class which implements the Catmull-Rom class of splines. More...

`#include <OgreSimpleSpline.h>`

List of all members.

## Public Member Functions

| SimpleSpline ()
| ~SimpleSpline ()
void | addPoint (const Vector3 &p)
| Adds a control point to the end of the spline.
const Vector3 & | getPoint (unsigned short index) const
| Gets the detail of one of the control points of the spline.
unsigned short | getNumPoints (void) const
| Gets the number of control points in the spline.
void | clear (void)
| Clears all the points in the spline.
void | updatePoint (unsigned short index, const Vector3 &value)
| Updates a single point in the spline.
Vector3 | interpolate (Real t)
| Returns an interpolated point based on a parametric value over the whole series.
Vector3 | interpolate (unsigned int fromIndex, Real t)
| Interpolates a single segment of the spline given a parametric value.
void | setAutoCalculate (bool autoCalc)
| Tells the spline whether it should automatically calculate tangents on demand as points are added.
void | recalcTangents (void)
| Recalculates the tangents associated with this spline.

## Protected Attributes

bool | mAutoCalc
std::vector< Vector3 > | mPoints
std::vector< Vector3 > | mTangents
Matrix4 | mCoeffs
| Matrix of coefficients.

## Detailed Description

A very simple spline class which implements the Catmull-Rom class of splines.

Remarks:
  Splines are bendy lines. You define a series of points, and the spline forms a smoother line between the points to eliminate the sharp angles.

  Catmull-Rom splines are a specialisation of the general Hermite spline. With a Hermite spline, you define the start and end point of the line, and 2 tangents, one at the start of the line and one at the end. The Catmull-Rom spline simplifies this by just asking you to define a series of points, and the tangents are created for you.

Definition at line 51 of file OgreSimpleSpline.h.

## Constructor & Destructor Documentation

Ogre::SimpleSpline::SimpleSpline | ( |  | ) |

Ogre::SimpleSpline::~SimpleSpline | ( |  | ) |

## Member Function Documentation

void Ogre::SimpleSpline::addPoint | ( | const Vector3 & | p | ) |

| Adds a control point to the end of the spline.

void Ogre::SimpleSpline::clear | ( | void |  | ) |

| Clears all the points in the spline.

unsigned short Ogre::SimpleSpline::getNumPoints | ( | void |  | ) | const

| Gets the number of control points in the spline.

const Vector3& Ogre::SimpleSpline::getPoint | ( | unsigned short | index | ) | const

| Gets the detail of one of the control points of the spline.

Vector3 Ogre::SimpleSpline::interpolate | ( | unsigned int | fromIndex,
|  | Real | t
| ) |

Interpolates a single segment of the spline given a parametric value.

Parameters:

  | fromIndex | The point index to treat as t=0. fromIndex + 1 is deemed to be t=1
  | t | Parametric value

Vector3 Ogre::SimpleSpline::interpolate | ( | Real | t | ) |

Returns an interpolated point based on a parametric value over the whole series.

Remarks:
  Given a t value between 0 and 1 representing the parametric distance along the whole length of the spline, this method returns an interpolated point.

Parameters:

  | t | Parametric value.

void Ogre::SimpleSpline::recalcTangents | ( | void |  | ) |

Recalculates the tangents associated with this spline.

Remarks:
  If you tell the spline not to update on demand by calling setAutoCalculate(false) then you must call this after completing your updates to the spline points.

void Ogre::SimpleSpline::setAutoCalculate | ( | bool | autoCalc | ) |

Tells the spline whether it should automatically calculate tangents on demand as points are added.

Remarks:
  The spline calculates tangents at each point automatically based on the input points. Normally it does this every time a point changes. However, if you have a lot of points to add in one go, you probably don't want to incur this overhead and would prefer to defer the calculation until you are finished setting all the points. You can do this by calling this method with a parameter of 'false'. Just remember to manually call the recalcTangents method when you are done.

Parameters:

  | autoCalc | If true, tangents are calculated for you whenever a point changes. If false, you must call reclacTangents to recalculate them when it best suits.

void Ogre::SimpleSpline::updatePoint | ( | unsigned short | index,
|  | const Vector3 & | value
| ) |

Updates a single point in the spline.

Remarks:
  This point must already exist in the spline.

## Member Data Documentation

bool Ogre::SimpleSpline::mAutoCalc`[protected]`

| Definition at line 113 of file OgreSimpleSpline.h.

Matrix4 Ogre::SimpleSpline::mCoeffs`[protected]`

| Matrix of coefficients. Definition at line 119 of file OgreSimpleSpline.h.

std::vector<Vector3> Ogre::SimpleSpline::mPoints`[protected]`

| Definition at line 115 of file OgreSimpleSpline.h.

std::vector<Vector3> Ogre::SimpleSpline::mTangents`[protected]`

| Definition at line 116 of file OgreSimpleSpline.h.

The documentation for this class was generated from the following file:

- OgreSimpleSpline.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:56 2008